/*************************************************************************************
 Data Visualization - Basic 3D Demo                

 Author: Weidi Zhang                        
 Supervisor: George Legrady                           

 Purpose: Show how to present volume data in a basic 3D environment     

 Usage:

1.Left-clicking and dragging will rotate the camera position about the center of the sketch
2.right-clicking and dragging will pan the camera position without rotation
3.using the mouse wheel (scrolling) will move the camera closer or further from the center of the sketch. 

2.Press 'a' 's''d''f' will show four different albums respectively

step 1. preload files
step 2. setup - initialize data and get basic information
step 3. draw - draw data titles and labels
step 4. user interface design and user interactions
 *************************************************************************************/

let table;
let color = ['yellow','red','green','lightblue'];
let boxSize=370;
let numRows, numCols;
let cellDepth=boxSize/11, cellWidth=boxSize/9;
let albumShow = [10];//boolean

function preload(){
    table1 = loadTable("data/2018_1.csv",'csv','header'); 
    table2 = loadTable("data/2018_2.csv",'csv','header'); 
    table3 = loadTable("data/2018_3.csv",'csv','header'); 
    table4 = loadTable("data/2018_4.csv",'csv','header'); 
    table5 = loadTable("data/2018_5.csv",'csv','header'); 
    table6 = loadTable("data/2018_6.csv",'csv','header'); 
    table7 = loadTable("data/2018_7.csv",'csv','header'); 
    table8 = loadTable("data/2018_8.csv",'csv','header'); 
    table9 = loadTable("data/2018_9.csv",'csv','header'); 
    table10 = loadTable("data/2018_10.csv",'csv','header'); 
    table11 = loadTable("data/2018_11.csv",'csv','header'); 
    table12 = loadTable("data/2018_12.csv",'csv','header'); 
    tableOut = loadTable("data/2018_out.csv",'csv','header'); 
    Gotham = loadFont('data/Gotham-Bold.otf');
    DIN = loadFont('data/DIN.otf');
}

let dataMatrix1 = [];
let dataMatrix2 = [];
let dataMatrix3 = [];
let dataMatrix4 = [];
let dataMatrix5 = [];
let dataMatrix6 = [];
let dataMatrix7 = [];
let dataMatrix8 = [];
let dataMatrix9 = [];
let dataMatrix10 = [];
let dataMatrix11 = [];
let dataMatrix12 = [];
let dataMatrixOut = [];

let inSize1 = 0;
let inSize2 = 0;
let inSize3 = 0;
let inSize4 = 0;
let inSize5 = 0;
let inSize6 = 0;
let inSize7 = 0;
let inSize8 = 0;
let inSize9 = 0;
let inSize10 = 0;
let inSize11 = 0;
let inSize12 = 0;
let outSize = 0;

let inSizeSet = [];
let outSizeSet = [];
let colorDew = ['#6163d3', '#6db7ca', '#fcf769', '#ffd23e', '#616f39', '#9876de', '#9adeb9', '#f1f4f6', '#2552ac', '#597fca', '#d9a2f1', '#d0efb5'];
let inColor = [];
let matrixSet = [dataMatrix1,dataMatrix2,dataMatrix3,dataMatrix4,dataMatrix5,dataMatrix6,dataMatrix7,dataMatrix8,dataMatrix9,dataMatrix10,dataMatrix11,dataMatrix12];

function setup(){
    smooth();
    createCanvas(windowWidth,windowHeight,WEBGL); // processing we use size(x,y, P3D)
    // Sets a perspective projection for the camera in a 3D sketch.
    // perspective([fovy], [aspect], [near], [far])
    perspective(PI / 3.0, width / height, 0.1, 5000);
    // get the basic information of data
    numRows= table1.getRowCount();
    numCols= table1.getColumnCount(); 
    print("Rows: " + numRows + " , Columns: " + numCols);  

    for (var a = 0; a<10; a++){
        albumShow[a]=true;
    }

    // retrieve data from table
    for(var i = 0; i <numRows; i++){
        dataMatrixOut[i]= []; //create nested array
        for(var j = 0; j < numCols-1; j++){
            dataMatrixOut[i][j] = tableOut.getNum(i,j+1);
        }
        outSizeSet.push(tableOut.getNum(i,numCols));
    }

    for(var i = 0; i <numRows; i++){
        dataMatrix1[i]= []; //create nested array
        for(var j = 0; j < numCols-1; j++){
            dataMatrix1[i][j] = table1.getNum(i,j+1);
            //console.log(dataMatrix1[i][j]);
            inSize1 += dataMatrix1[i][j];
        }
    }

    for(var i = 0; i <numRows; i++){
        dataMatrix2[i]= []; //create nested array
        for(var j = 0; j < numCols-1; j++){
            dataMatrix2[i][j] = table2.getNum(i,j+1);
            inSize2 += dataMatrix2[i][j];
        }
    } 

    for(var i = 0; i <numRows; i++){
        dataMatrix3[i]= []; //create nested array
        for(var j = 0; j < numCols-1; j++){
            dataMatrix3[i][j] = table3.getNum(i,j+1);
            inSize3 += dataMatrix3[i][j];
        }
    } 

    for(var i = 0; i <numRows; i++){
        dataMatrix4[i]= []; //create nested array
        for(var j = 0; j < numCols-1; j++){
            dataMatrix4[i][j] = table4.getNum(i,j+1);
            inSize4 += dataMatrix4[i][j];
        }
    } 

    for(var i = 0; i <numRows; i++){
        dataMatrix5[i]= []; //create nested array
        for(var j = 0; j < numCols-1; j++){
            dataMatrix5[i][j] = table5.getNum(i,j+1);
            inSize5 += dataMatrix5[i][j];
        }
    } 

    for(var i = 0; i <numRows; i++){
        dataMatrix6[i]= []; //create nested array
        for(var j = 0; j < numCols-1; j++){
            dataMatrix6[i][j] = table6.getNum(i,j+1);
            inSize6 += dataMatrix6[i][j];
        }
    } 

    for(var i = 0; i <numRows; i++){
        dataMatrix7[i]= []; //create nested array
        for(var j = 0; j < numCols-1; j++){
            dataMatrix7[i][j] = table7.getNum(i,j+1);
            inSize7 += dataMatrix7[i][j];
        }
    } 
    for(var i = 0; i <numRows; i++){
        dataMatrix8[i]= []; //create nested array
        for(var j = 0; j < numCols-1; j++){
            dataMatrix8[i][j] = table8.getNum(i,j+1);
            inSize8 += dataMatrix8[i][j];
        }
    } 
    for(var i = 0; i <numRows; i++){
        dataMatrix9[i]= []; //create nested array
        for(var j = 0; j < numCols-1; j++){
            dataMatrix9[i][j] = table9.getNum(i,j+1);
            inSize9 += dataMatrix9[i][j];
        }
    } 
    for(var i = 0; i <numRows; i++){
        dataMatrix10[i]= []; //create nested array
        for(var j = 0; j < numCols-1; j++){
            dataMatrix10[i][j] = table10.getNum(i,j+1);
            inSize10 += dataMatrix10[i][j];
        }
    } 
    for(var i = 0; i <numRows; i++){
        dataMatrix11[i]= []; //create nested array
        for(var j = 0; j < numCols-1; j++){
            dataMatrix11[i][j] = table11.getNum(i,j+1);
            inSize11 += dataMatrix11[i][j];
        }
    } 
    for(var i = 0; i <numRows; i++){
        dataMatrix12[i]= []; //create nested array
        for(var j = 0; j < numCols-1; j++){
            dataMatrix12[i][j] = table12.getNum(i,j+1);
            inSize12 += dataMatrix12[i][j];
        }
    } 
    inSizeSet = [inSize1, inSize2, inSize3, inSize4, inSize5, inSize6, inSize7, inSize8, inSize9, inSize10, inSize11, inSize12];
}

function draw(){
    background(35);
    //Allows movement around a 3D sketch using a mouse
    orbitControl();
    lights();
    //origin in WEBGL is the center of the canvas
    fill(180,180,180,80);
    drawLabel();
    drawCurve(albumShow);
}

function keyTyped() {
    //press each number to ban/show different dew class
    if (key === '1') {
        albumShow[0] =!albumShow[0];
        console.log('1 typed');
    }else if(key === '2'){
        albumShow[1] =!albumShow[1];
    }else if(key === '3'){
        albumShow[2] =!albumShow[2];
    }else if(key === '4'){
        albumShow[3] =!albumShow[3];
    }else if(key === '5'){
        albumShow[4] =!albumShow[4];
    }else if(key === '6'){
        albumShow[5] =!albumShow[5];
    }else if(key === '7'){
        albumShow[6] =!albumShow[6];
    }else if(key === '8'){
        albumShow[7] =!albumShow[7];
    }else if(key === '9'){
        albumShow[8] =!albumShow[8];
    }else if(key === '0'){
        albumShow[9] =!albumShow[9];
    }
}




















