// ctrl + opt + I
let pointMin = 5, pointMax = 18;
let gapText = 13;
let startYear = 2008; 
let pointScale = 100;
let curveScale = 0.1;
var monthName = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
let albumShow = [10];//boolean

function drawCurve(){
    for (var a = 0; a<10; a++){
        albumShow[a]=true;
    }
    for (var month = 0; month < 12; month++){
        let dataMatrix = matrixSet[month];
        let xPos1 = sin((PI/6)*month)*4*pointScale;
        let yPos1 = cos((PI/6)*month)*4*pointScale;
        let zPos1 = 0;
        //translate(xPos1 + boxSize, yPos1 - boxSize, -zPos1 - boxSize/2);
        let pointSize = inSizeSet[month]/2000;

        push();
        //translate(xPos - boxSize/2, yPos, -zPos + boxSize/2);
        stroke(colorDew[7]);
        //stroke('white');
        strokeWeight(pointSize);
        //point(0,0,0);
        point(xPos1,yPos1,zPos1)
        pop();

        let z2Pos = 500;
        let point2Size = outSizeSet[month]/2000;

        push();
        //translate(x2Pos - boxSize/2, y2Pos, -z2Pos + boxSize/2);
        stroke('white');
        strokeWeight(point2Size);
        //point(0,0,0);
        point(xPos1,yPos1,z2Pos)
        pop();

        for (var i = 0; i < 12; i ++){

            let xPos4 = sin((PI/6)*i)*4*pointScale;
            let yPos4 = cos((PI/6)*i)*4*pointScale;
            let zPos4 = 500;
            //translate(xPos4 - boxSize/2, yPos4, -zPos4 + boxSize/2);

            var xPos2,yPos2,zPos2,xPos3,yPos3,zPos3;

            for (var j = 0; j < 10; j++){
                if (albumShow[j]){
                    xPos2 = sin(((j-1)*PI/5)*i)*4*curveScale;
                    yPos2 = cos(((j-1)*PI/5)*i)*4*curveScale;
                    zPos2 = curveScale*i/2+500;
    
                    xPos3 = sin((j*PI/5)*i)*4*curveScale;
                    yPos3 = cos((j*PI/5)*i)*4*curveScale;
                    zPos3 = curveScale*i/2+500;
    
                    push();
                    //translate(xPos2 - boxSize/2, yPos2, -zPos2 + boxSize/2);
                    //translate(xPos3 - boxSize/2, yPos3, -zPos3 + boxSize/2);
                    stroke(colorDew[j]);
                    strokeWeight(dataMatrix[i][j]/1000);
                    bezier(xPos1,yPos1,zPos1, xPos2,yPos2,zPos2, xPos3,yPos3,zPos3, xPos4,yPos4,zPos4);
                    pop();
                }
            }
        }
    }
}

//draw points which represented as month
function drawPoints(){
    for(var i = 0; i < 12; i++){    // 10 years with 12 months for each
        let xPos = sin((PI/6)*i)*4*pointScale;
        let yPos = cos((PI/6)*i)*4*pointScale;
        let zPos = 0;
        let pointSize = inSizeSet[i]/2000;

        push();
        translate(xPos - boxSize/2, yPos, -zPos + boxSize/2);
        stroke(colorDew[7]);
        //stroke('white');
        strokeWeight(pointSize);
        point(0,0,0);
        pop();

        let x2Pos = sin((PI/6)*i)*4*pointScale;
        let y2Pos = cos((PI/6)*i)*4*pointScale;
        let z2Pos = pointScale*i/2+500;
        let point2Size = outSizeSet[i]/2000;

        push();
        translate(x2Pos - boxSize/2, y2Pos, -z2Pos + boxSize/2);
        stroke('white');
        strokeWeight(point2Size);
        point(0,0,0);
        pop();
    }
}
//draw labels
function drawLabel(){
    for (var i = 0; i < 12; i++){
        let xPos = sin((PI/6)*i)*5*pointScale -50;
        let yPos = cos((PI/6)*i)*5*pointScale;
        let zPos = 0;
        let pointSize = inSizeSet[i]/2000;

        push();
        fill('white');
        translate(xPos, yPos, -zPos);
        textFont(Gotham);
        textSize(25);
        textAlign(CENTER);
        text(monthName[i], cellWidth, 0);
        pop();


        // let x2Pos = sin((PI/6)*i)*4*pointScale;
        // let y2Pos = cos((PI/6)*i)*4*pointScale;
        // let z2Pos = 450;
        // push();
        // fill('white');
        // //translate(x2Pos - boxSize/2, y2Pos, -z2Pos + boxSize/2);
        // textFont(Gotham);
        // textSize(25);
        // textAlign(CENTER);
        // text(monthName[i], cellWidth, 0);
        // pop();
    }
}

